#include <stdlib.h>
#include <stdio.h>

#define MAX 5

void PrintArray(const int *ar, int nSize)
{
        int i;
        for(i = 0; i < nSize; i ++) 
			printf("%d ", ar[i]);
        printf("\n");
}
 

void MergeSort(int ar[], int left, int right, int pivot)
{
        if(left == right) 
			return;
        else
        {
              MergeSort(ar, left, pivot, (left + pivot) / 2);               
              MergeSort(ar, pivot + 1, right, (pivot + right + 1) / 2);   
        }
		
		int LeftIndex  = left, 
			PivotIndex = pivot + 1;
        while(PivotIndex != right + 1 && LeftIndex != PivotIndex) //continue until either list runs out
        {
            if(ar[PivotIndex] <= ar[LeftIndex])
			{
				int i;
				int iSrc = PivotIndex;
                int iDest= LeftIndex;
				int StoreSrc = ar[iSrc];     
				for(i = iSrc; i > iDest; i --) 
					ar[i] = ar[i - 1];    // Shifts numbers from iDest to iSrc one step forward
				ar[iDest] = StoreSrc;     // Puts final element in the right place
				PivotIndex++;
				LeftIndex++;
			}
            else 
				LeftIndex++; // Skip to the next element
        }    
}
 
int main(void)
{
        int ar[MAX] = { 46, 35 , 81 , 21, 22 };
        printf("Original array:\t"); 
		PrintArray(ar, MAX);
        MergeSort(ar, 0, MAX - 1, MAX / 2);   // Call to merge sort the array
        printf("Sorted array:\t"); 
		PrintArray(ar, MAX);
        return 0;
}
