#include <stdlib.h>
#include <stdio.h>

#define MAX 5

void PrintArray(const int *ar, int nSize)
{
        register int i;
        for(i = 0; i < nSize; i ++) 
			printf("%d ", ar[i]);
        printf("\n");
}
 
 
void ShiftandMoveToDest(int ar[], int iDest, int iSrc)
{
        int i;
        int StoreSrc = ar[iSrc];     
        for(i = iSrc; i > iDest; i --) 
				ar[i] = ar[i - 1];    // Shifts numbers from iDest to iSrc one step forward
        ar[iDest] = StoreSrc;                         // Puts final element in the right place
}
 
void CombineTwoArrays(int ar[], const int left, const int right, const int pivot)
{
        int LeftIndex  = left, 
			PivotIndex = pivot + 1;
        while(PivotIndex != right + 1 && LeftIndex != PivotIndex) //continue until either list runs out
        {
            if(ar[PivotIndex] <= ar[LeftIndex])            			   // Move the element at PivotIndex in front of the element at LeftIndex
				ShiftandMoveToDest(ar, LeftIndex ++ , PivotIndex ++); // MoveToDestAndShift(array, destination index, source index)
            else 
				LeftIndex++; // Skip to the next element
        }
}
 
void MergeSort(int ar[], int left, int right, int pivot)
{
        if(left == right) 
			return;
        else
        {
              MergeSort(ar, left, pivot, (left + pivot) / 2);               
              MergeSort(ar, pivot + 1, right, (pivot + right + 1) / 2);   
        }
        CombineTwoArrays(ar, left, right, pivot);    
}
 
int main(void)
{
        int ar[MAX] = { 46, 35 , 81 , 21, 22 };
        printf("Original array:\t"); 
		PrintArray(ar, MAX);
        MergeSort(ar, 0, MAX - 1, MAX / 2);   // Call to merge sort the array
        printf("Sorted array:\t"); 
		PrintArray(ar, MAX);
        return 0;
}
